#pragma once

//game client listener
namespace a8
{
    class TcpListener;
}

namespace f8
{
    struct MsgHdr;
}

namespace im
{
    class IMSocketConnect;
    class IMSocketDisconnect;
}

class GCListener : public a8::Singleton<GCListener>
{
 private:
    GCListener() {};
    friend class a8::Singleton<GCListener>;

 public:
    enum { HID = HID_GCListener };

 public:
    void Init();
    void UnInit();

    template <typename T>
    void SendMsg(unsigned short socket_handle, T& msg)
    {
        static int msgid = f8::Net_GetMessageId(msg);
        f8::Net_SendMsg(tcp_listener_, socket_handle, 0, msgid, msg);
    }

    void _F8_IMSocketConnect(f8::MsgHdr& hdr, const im::IMSocketConnect& msg);
    void _F8_IMSocketDisconnect(f8::MsgHdr& hdr, const im::IMSocketDisconnect& msg);

    void ForwardTargetConnMsg(f8::MsgHdr& hdr);
    void SendText(unsigned short sockhandle, const std::string& text);

    void ForceCloseClient(unsigned short sockhandle);
    void MarkClient(unsigned short sockhandle, bool is_active);
    long long GetSendNodeNum();
    long long GetSentBytesNum();
    bool GetWebSocketUrl(int socket_handle, std::string& url, std::string& query_str);

 private:
    std::map<int, std::tuple<std::string, std::string>> websocket_url_hash_;
    a8::TcpListener *tcp_listener_ = nullptr;
};
