#pragma once

class JsonDataMgr : public a8::Singleton<JsonDataMgr>
{
 private:
    JsonDataMgr() {};
    friend class a8::Singleton<JsonDataMgr>;

 public:
    void Init();
    void UnInit();

    std::shared_ptr<a8::XObject> GetConf();
    std::shared_ptr<a8::XObject> GetMasterServerClusterConf();
#if MASTER_MODE
    bool GetNodeHost(int node_id, std::string& host);
#else
    std::shared_ptr<a8::XObject> GetTargetServerClusterConf();
#endif

 private:
    std::string work_path_ = "../config";
    a8::XObject wsproxyserver_cluster_json_;
    a8::XObject masterserver_cluster_json_;
#if MASTER_MODE
    std::mutex* node_host_mutex_ = nullptr;
    a8::XObject routing_tables_json_;
    std::map<int, std::string> node_host_hash_;
#else
    a8::XObject targetserver_cluster_json_;
#endif
};
